//tabstop=4
//*****************************************************************************/
// Project: ORBAsec
//
// -------------------------------------------------------------------------
// Copyright (C) 1998 Polar Humenn
//                    All rights reserved.
// -------------------------------------------------------------------------
// $Id$
//*****************************************************************************/

package hello;

import org.omg.CORBA.*;
import java.io.*;
import org.omg.Security.*;
import org.omg.SecurityLevel2.Credentials;
import org.omg.SecurityLevel2.ReceivedCredentials;

public class Relay_impl extends _RelayImplBase
{
	org.omg.CORBA.ORB orb;
	hello.Hello       hello = null;
	
	private void get_hello()
	{
		if (hello != null)
			return;
			
	    // 
		// Get "hello" object
    	//
		System.out.println("Getting Hello Reference");
    	String ref = null;
    	try {
			String refFile = "Hello.ref";
			FileInputStream file = new FileInputStream(refFile);
			BufferedReader in =
				new BufferedReader(new InputStreamReader(file));
			ref = in.readLine();
			file.close();
    	} catch(IOException ex) {
			System.err.println("Can't read from `" +
				   ex.getMessage() + "'");
			System.exit(1);
    	}

    	org.omg.CORBA.Object obj = orb.string_to_object(ref);
    	if(obj == null)
			throw new RuntimeException();


		hello = HelloHelper.narrow(orb.string_to_object(ref));
		if(hello == null)
			throw new RuntimeException();
	}
	
    public boolean relay(byte[] intended_security_name,
	                     DelegationMode intended_del_mode)
    {
		System.out.println("Relay!");
		
		try {
		
			get_hello();
		
			orbasec.SecLev2.Current current = 
				orbasec.SecLev2.CurrentHelper.narrow(
					orb.resolve_initial_references("SecurityCurrent"));


			org.omg.SecurityLevel2.ReceivedCredentials rcreds = 
			    org.omg.SecurityLevel2.ReceivedCredentialsHelper.narrow(
							current.received_credentials());


			System.out.println("Received Credentials:");
   			orbasec.corba.CredUtil.dumpCredentials(rcreds);

			// If our received credentials are useful for delegation then
			// use them. We can do this just by setting the 

			org.omg.CORBA.Policy[] policies = new org.omg.CORBA.Policy[1];

			if (rcreds.delegation_mode() != DelegationMode.SecDelModeNoDelegation ) {
				 Credentials[] cl = new Credentials[1];
				 cl[0] = rcreds;
				 policies[0] = orbasec.SL2.create_invoc_creds_policy(cl);
			} else {
				 policies[0] = orbasec.SL2 .create_invoc_creds_policy(
				                                 current.own_credentials());
			}

			hello = HelloHelper.narrow(hello._set_policy_overrides(policies, 
										org.omg.CORBA.SetOverrideType.ADD_OVERRIDE));

			return hello.hello(intended_security_name, intended_del_mode);


		} catch (org.omg.CORBA.ORBPackage.InvalidName e) {
			e.printStackTrace(System.out);
			throw new org.omg.CORBA.UNKNOWN(e.toString());
		} catch (org.omg.CORBA.PolicyManagerPackage.InvalidPolicies e) {
			e.printStackTrace(System.out);
			throw new org.omg.CORBA.UNKNOWN(e.toString());
		} catch (org.omg.CORBA.SystemException e) {
			e.printStackTrace(System.out);
			throw e;
		}
    }
}
