//tabstop=4
//*****************************************************************************/
// Project: ORBAsec
//
// -------------------------------------------------------------------------
// Copyright (C) 1998 Polar Humenn
//                    All rights reserved.
// -------------------------------------------------------------------------
// $Id$
//*****************************************************************************/

package hello;

import org.omg.CORBA.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import orbasec.corba.*;
import orbasec.corba.Opaque;
import org.omg.Security.*;

public class Client
{
	static ORB orb;
	static BOA boa;
	static orbasec.SecLev2.Current current;

	
	// Object reference 
	static Hello  hello;

	// Intended Security Names for the Client and the Relay that
	// the Hello server should verify;
	static org.omg.Security.SecAttribute our_accessid;
	
	// The string form of the our_accessid.value
	static String                        our_name;
	
	private static Hello get_hello()
	{
    	// 
		// Get "hello" object
    	//
		//System.out.println("Getting Hello Reference");
    	String ref = null;
    	try {
			String refFile = "Hello.ref";
			FileInputStream file = new FileInputStream(refFile);
			BufferedReader in =
				new BufferedReader(new InputStreamReader(file));
			ref = in.readLine();
			file.close();
    	} catch(IOException ex) {
			System.err.println("Can't read from `" +
				   ex.getMessage() + "'");
			System.exit(1);
    	}

    	org.omg.CORBA.Object obj = orb.string_to_object(ref);
    	if(obj == null)
			throw new RuntimeException();


		Hello hello = HelloHelper.narrow(orb.string_to_object(ref));
		if(hello == null)
			throw new RuntimeException();
		return hello;
	}
	
	private static void init(String args[])
		throws org.omg.CORBA.ORBPackage.InvalidName
	{
			//
			// ORB, BOA, and SL2 initialization
			//
			java.util.Properties properties = new java.util.Properties();
			orbasec.SL2.init_with_boa( 
				args, properties, properties );
			orb = orbasec.SL2.orb();
			boa = orbasec.SL2.boa();

    		// 
    		// Get SecurityLevel2::Current from ORB
    		// 
    		current = 
				orbasec.SecLev2.CurrentHelper.narrow(
					orb.resolve_initial_references("SecurityCurrent"));
	}

	private static void authenticate()
	{
		// done automatically through krb session credentials
	}
	
	private static void setup_references()
		throws  org.omg.CORBA.PolicyManagerPackage.InvalidPolicies,
		        org.omg.CORBA.ORBPackage.InvalidName
	{
		hello = get_hello();

		our_accessid = orbasec.corba.CredUtil.getAccessIdAttribute(
								current.own_credentials()[0]);
		try {
			our_name = Opaque.decode(our_accessid.value).toString();
		} catch (Opaque.CodingException e) {
			our_name = "<error decoding>";
		}
	}
	
	private static void test()
	{
		boolean ret;
		int     exitval = 0;
		org.omg.Security.SecAttributeHolder accessid = 
			new org.omg.Security.SecAttributeHolder();
		org.omg.CORBA.ShortHolder opts = 
			new org.omg.CORBA.ShortHolder();
		
		hello.hello(accessid);
		if (!orbasec.corba.CredUtil.equals(our_accessid,accessid.value)) {
			System.out.println("Test Failed on hello for \"" + our_name + "\".");
			exitval |= 1;
		}
		if (exitval == 0)
			System.out.println("Test Succeeded for \"" + our_name + "\".");
		System.exit(exitval);
	}


	private static void dump_creds()
	{
		//
		// Print credentials to screen
		//
		org.omg.SecurityLevel2.Credentials[] credlist = 
			current.own_credentials();
		System.out.println("Own Credentials:");
		orbasec.corba.CredUtil.dumpCredentials(credlist);
	}
	
	
    //
    // Standalone program initialization
    //
    public static void main(String args[])
    {
    	try {
			init(args);
			authenticate();
			dump_creds();
			setup_references();
			
			test(); // This will exit
				
   	} catch(Exception ex) {
			System.err.println(ex.getMessage());
			ex.printStackTrace();
			System.exit(1);
    	}
    }
}
