//tabstop=4
//*****************************************************************************/
// Project: ORBAsec
//
// File:    Client.java
// Date:    August 1998
//
// Description:
//              This file is a modification of ORBacus 3.0 hello demo modified
//   to illustrate Adiron's ORBAsec SL2 (SecurityLevel2).  
//
// -------------------------------------------------------------------------
// Copyright (C) 1998 Polar Humenn
//                    All rights reserved.
// -------------------------------------------------------------------------
// $Id$
//*****************************************************************************/

package hello;


public class Client 
extends java.applet.Applet 
{
	org.omg.SecurityLevel2.Current current_ = null;
	Hello                            hello_ = null;
	
	public void init()
    {
		String ior = getParameter("ior");
		//
		// Create ORB
		//
 		java.util.Properties properties = new java.util.Properties();
		orbasec.SL2.init( this, properties );
		org.omg.CORBA.ORB orb = orbasec.SL2.orb();
		org.omg.CORBA.BOA boa = orbasec.SL2.boa();
    	
		try {
			current_ = 
				org.omg.SecurityLevel2.CurrentHelper.narrow(
	    			orb.resolve_initial_references("SecurityCurrent"));
		} catch ( org.omg.CORBA.ORBPackage.InvalidName in ){
			in.printStackTrace();
		}
		
		authenticate();
		//print_credentials();

		//
		// Create client object
		//
		org.omg.CORBA.Object obj = orb.string_to_object(ior);
		if(obj == null)
	    	throw new RuntimeException();

		hello_ = HelloHelper.narrow(obj);

		//
		// Add hello button
		//
		java.awt.Button button = new java.awt.Button("Hello");
		button.addActionListener( button_listener_ );
		this.add( button );
    }


    public void 
	authenticate()
    {
    	org.omg.SecurityLevel2.PrincipalAuthenticator pa = 
			current_.principal_authenticator();

		String  mechanism = orbasec.corba.MechUtil.SSL_DH_DSS_EXPORT_MECH;;
		int	    method    = 0;
		byte	security_name[] = new byte[0]; // assigned from cert
		byte	auth_data[] =
			    ("cert_file=client.pem\n" +
				 "passphrase=\"blahblah\"\n" +
				 "enable_server=false\n" ).getBytes();
		org.omg.Security.SecAttribute privileges[] =
			new org.omg.Security.SecAttribute[0];
		org.omg.SecurityLevel2.CredentialsHolder creds =
			new org.omg.SecurityLevel2.CredentialsHolder();
		org.omg.Security.OpaqueHolder
		 continuation_data =
			new org.omg.Security.OpaqueHolder(),
		 auth_specific_data =
			new org.omg.Security.OpaqueHolder();

		pa.authenticate(
			method,
			mechanism,
			security_name,
			auth_data,
			privileges,
			creds,
			continuation_data,
			auth_specific_data
		);
	}
		
	void
	print_credentials()
	{
		System.out.println("Own Credentials:");
		orbasec.corba.CredUtil.dumpCredentials(
			current_.own_credentials() );
	}
    
	

	private class ButtonListener
	implements java.awt.event.ActionListener
	{
		public void
		actionPerformed( java.awt.event.ActionEvent event )
		{
			hello_.hello();
		}
	}
	ButtonListener button_listener_ =
		new ButtonListener();
}
