//tabstop=4
//*****************************************************************************/
// Project: ORBAsec
//
// File:    Server.java
// Date:    August 1998
//
// Description:
//              This file is a modification of ORBacus 3.0 hello demo modified
//   to illustrate Adiron's ORBAsec SL2 (SecurityLevel2).  
//
// -------------------------------------------------------------------------
// Copyright (C) 1998 Polar Humenn
//                    All rights reserved.
// -------------------------------------------------------------------------
// $Id$
//*****************************************************************************/
// **********************************************************************
//
// Copyright (c) 1997
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1997
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package hello;

import org.omg.CORBA.*;
import java.io.*;
import orbasec.corba.Opaque;

public class Server
{
	public static void main(String args[])
	{
		try {
			//
			// ORB, BOA, and SL2 initialization
			//
 			java.util.Properties properties = new java.util.Properties();
			orbasec.SL2.init_with_boa( args, properties, properties );
			org.omg.CORBA.ORB orb = orbasec.SL2.orb();
			org.omg.CORBA.BOA boa = orbasec.SL2.boa();

    		// 
    		// Get SecurityLevel2::Current from ORB
    		// 
    		org.omg.SecurityLevel2.Current current = 
			org.omg.SecurityLevel2.CurrentHelper.narrow(
	    		orb.resolve_initial_references("SecurityCurrent"));

    		//
    		// Authenticate using PrincipalAuthenticator
    		//
    		org.omg.SecurityLevel2.PrincipalAuthenticator pa;
    		pa = current.principal_authenticator();

			// We have a DH certficate with a DSA signature.
			String  mechanism = orbasec.corba.MechUtil.SSL_DH_DSS_EXPORT_MECH;
			int	    method    = 0;
			byte	security_name[] = new byte[0]; // assigned from cert
			byte	auth_data[] =
			        ("cert_file=server.pem\n" +
					 "passphrase=\"blahblah\"\n" +
					 "enable_server=true\n" ).getBytes();
			org.omg.Security.SecAttribute privileges[] =
				new org.omg.Security.SecAttribute[0];
			org.omg.SecurityLevel2.CredentialsHolder creds_holder =
				new org.omg.SecurityLevel2.CredentialsHolder();
			org.omg.Security.OpaqueHolder
			 continuation_data =
				new org.omg.Security.OpaqueHolder(),
			 auth_specific_data =
				new org.omg.Security.OpaqueHolder();

			pa.authenticate(
				method,
				mechanism,
				security_name,
				auth_data,
				privileges,
				creds_holder,
				continuation_data,
				auth_specific_data
			);

			//
			// Print credentials to screen
			//
			org.omg.SecurityLevel2.Credentials[] credlist = 
				current.own_credentials();
			System.out.println("Own Credentials:");
			for( int i = 0;  i < credlist.length;  i++ ) {	
				orbasec.corba.CredUtil.dumpCredentials(credlist[i]);
			}

			//
			// Create implementation object
			//
			Hello_impl p = new Hello_impl();
			p.orb        = orb;

			//
			// Save reference
			//
			try {
				String           ref = orb.object_to_string(p);
				String           refFile;
				FileOutputStream file;
				PrintWriter      out;
				
				refFile = "Hello.ref";
				file    = new FileOutputStream(refFile);
				out     = new PrintWriter(file);
				out.println(ref);
				out.flush();
				file.close();
				
				refFile = "Hello.html";
				file    = new FileOutputStream(refFile);
				out     = new PrintWriter(file);
				out.println(
					"<applet\n" +
					"    codebase=classes\n" +
					"    code=\"hello/Client.class\"\n" +
					"    archive=\"jdk11x_update.jar,iaik_jce.jar,iaik_ssl.jar,OB.jar,SL2.jar,SSL_IAIK.jar\"\n" +
					"    width=500\n" +
					"    height=300>\n" +
					"       <param name=org.omg.CORBA.ORBClass value=com.ooc.CORBA.ORB>\n" +
					"       <param name=org.omg.CORBA.ORBSingletonClass value=com.ooc.CORBA.ORBSingleton>\n" +
					"       <param name=ior value="+ref+">\n" +
					"</applet>\n"
				);
				
				
				out.flush();
				file.close();
			} catch(IOException ex) {
				System.err.println("Can't write to `" +
						   ex.getMessage() + "'");
				System.exit(1);
			}

			//
			// Run implementation
			//
			boa.impl_is_ready(null);

			System.exit(0);
		} catch(Exception ex) {
			System.err.println(ex.getMessage());
			ex.printStackTrace();
			System.exit(1);
		}
	}
}
