//tabstop=4
//*****************************************************************************/
// Project: ORBAsec
//
// -------------------------------------------------------------------------
// Copyright (C) 1998 Polar Humenn
//                    All rights reserved.
// -------------------------------------------------------------------------
// $Id$
//*****************************************************************************/

package hello;

import org.omg.CORBA.*;
import java.io.*;
import orbasec.corba.Opaque;

public class RelayServer
{
	public static void main(String args[])
	{
		try {
			//
			// ORB, BOA, and SL2 initialization
			//
			java.util.Properties properties = new java.util.Properties();
			orbasec.SL2.init_with_boa( 
				args, properties, properties );
			ORB orb = orbasec.SL2.orb();
			BOA boa = orbasec.SL2.boa();

    		// 
    		// Get SecurityLevel2::Current from ORB
    		// 
    		org.omg.SecurityLevel2.Current current = 
			org.omg.SecurityLevel2.CurrentHelper.narrow(
	    		orb.resolve_initial_references("SecurityCurrent"));

    		//
    		// Authenticate using PrincipalAuthenticator
    		//
    		org.omg.SecurityLevel2.PrincipalAuthenticator pa;
    		pa = current.principal_authenticator();

			String  mechanism = orbasec.corba.MechUtil.SSL_DH_DSS_EXPORT_MECH;
			int	    method    = 0;
			byte	security_name[] = new byte[0]; // assigned from cert
			byte	auth_data[] =
			        ("cert_file=relay_server.pem\n" +
					 "passphrase=\"blahblah\"\n" +
					 "enable_server=true\n" ).getBytes();
			org.omg.Security.SecAttribute privileges[] =
				new org.omg.Security.SecAttribute[0];
			org.omg.SecurityLevel2.CredentialsHolder creds_holder =
				new org.omg.SecurityLevel2.CredentialsHolder();
			org.omg.Security.OpaqueHolder
			 continuation_data =
				new org.omg.Security.OpaqueHolder(),
			 auth_specific_data =
				new org.omg.Security.OpaqueHolder();

			pa.authenticate(
				method,
				mechanism,
				security_name,
				auth_data,
				privileges,
				creds_holder,
				continuation_data,
				auth_specific_data
			);

			//
			// Print credentials to screen
			//
			org.omg.SecurityLevel2.Credentials[] credlist = 
				current.own_credentials();
			System.out.println("Own Credentials:");
			for( int i = 0;  i < credlist.length;  i++ ) {	
				orbasec.corba.CredUtil.dumpCredentials(credlist[i]);
			}
			
			// Turn on EstablishTrustInClient requirement
			creds_holder.value.accepting_options_required( (short) 
				(creds_holder.value.accepting_options_required() |
				 org.omg.Security.EstablishTrustInClient.value));
			

			//
			// Create implementation object
			//
			Relay_impl p = new Relay_impl();
			p.orb        = orb;

			//
			// Save reference
			//
			try {
				String ref = orb.object_to_string(p);
				String refFile = "Relay.ref";
				FileOutputStream file = new FileOutputStream(refFile);
				PrintWriter out = new PrintWriter(file);
				out.println(ref);
				out.flush();
				file.close();
			} catch(IOException ex) {
				System.err.println("Can't write to `" +
						   ex.getMessage() + "'");
				System.exit(1);
			}

			//
			// Run implementation
			//
			boa.impl_is_ready(null);

			System.exit(0);
		} catch(Exception ex) {
			System.err.println(ex.getMessage());
			ex.printStackTrace();
			System.exit(1);
		}
	}
}
